ExpressionEvaluator (JSP 3.1 API Documentation - Apache Tomcat 10.1.5)

Package jakarta.servlet.jsp.el

## Class ExpressionEvaluator

- java.lang.Object
- - jakarta.servlet.jsp.el.ExpressionEvaluator

-     @Deprecated
      public abstract class ExpressionEvaluator
      extends java.lang.Object

  Deprecated.
  As of JSP 2.1, replaced by jakarta.el.ExpressionFactory

  The abstract base class for an expression-language evaluator. Classes that implement an expression language expose their functionality via this abstract class.

  An instance of the ExpressionEvaluator can be obtained via the JspContext / PageContext

  The parseExpression() and evaluate() methods must be thread-safe. That is, multiple threads may call these methods on the same ExpressionEvaluator object simultaneously. Implementations should synchronize access if they depend on transient state. Implementations should not, however, assume that only one object of each ExpressionEvaluator type will be instantiated; global caching should therefore be static.

  Only a single EL expression, starting with '${' and ending with '}', can be parsed or evaluated at a time. EL expressions cannot be mixed with static text. For example, attempting to parse or evaluate " `abc${1+1}def${1+1}ghi`" or even "`${1+1}${1+1}`" will cause an `ELException` to be thrown.

  The following are examples of syntactically legal EL expressions:

  - `${person.lastName}`
  - `${8 * 8}`
  - `${my:reverse('hello')}`
  Since:
    JSP 2.0

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ExpressionEvaluator()` | Deprecated.

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Deprecated Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `abstract java.lang.Object` | `evaluate​(java.lang.String expression, java.lang.Class<?> expectedType, VariableResolver vResolver, FunctionMapper fMapper)` | Deprecated. Evaluates an expression.
    `abstract Expression` | `parseExpression​(java.lang.String expression, java.lang.Class<?> expectedType, FunctionMapper fMapper)` | Deprecated. Prepare an expression for later evaluation.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ExpressionEvaluator

          public ExpressionEvaluator()

      Deprecated.

  - ### Method Detail

    - #### parseExpression

          public abstract Expression parseExpression​(java.lang.String expression,
                                                     java.lang.Class<?> expectedType,
                                                     FunctionMapper fMapper)
                                              throws ELException

      Deprecated.
      Prepare an expression for later evaluation. This method should perform syntactic validation of the expression; if in doing so it detects errors, it should raise an ELParseException.
      Parameters:
        `expression` - The expression to be evaluated.
        `expectedType` - The expected type of the result of the evaluation
        `fMapper` - A FunctionMapper to resolve functions found in the expression. It can be null, in which case no functions are supported for this invocation. The ExpressionEvaluator must not hold on to the FunctionMapper reference after returning from `parseExpression()`. The `Expression` object returned must invoke the same functions regardless of whether the mappings in the provided `FunctionMapper` instance change between calling `ExpressionEvaluator.parseExpression()` and `Expression.evaluate()`.
      Returns:
        The Expression object encapsulating the arguments.
      Throws:
        `ELException` - Thrown if parsing errors were found.

    - #### evaluate

          public abstract java.lang.Object evaluate​(java.lang.String expression,
                                                    java.lang.Class<?> expectedType,
                                                    VariableResolver vResolver,
                                                    FunctionMapper fMapper)
                                             throws ELException

      Deprecated.
      Evaluates an expression. This method may perform some syntactic validation and, if so, it should raise an ELParseException error if it encounters syntactic errors. EL evaluation errors should cause an ELException to be raised.
      Parameters:
        `expression` - The expression to be evaluated.
        `expectedType` - The expected type of the result of the evaluation
        `vResolver` - A VariableResolver instance that can be used at runtime to resolve the name of implicit objects into Objects.
        `fMapper` - A FunctionMapper to resolve functions found in the expression. It can be null, in which case no functions are supported for this invocation.
      Returns:
        The result of the expression evaluation.
      Throws:
        `ELException` - Thrown if the expression evaluation failed.